#include "Adafruit_WS2801.h"
//#include "SPI.h"

//stores the last time the LED strip updated
unsigned long previousMillis1 = 0;
unsigned long currentMillis = 0;

uint8_t dataPin  = 23; // Yellow wire 
uint8_t clockPin = 25; // Green wire

Adafruit_WS2801 strip = Adafruit_WS2801(15, dataPin, clockPin);

//higher velocity usually makes MIDI instruments louder
int velocity = 100;//velocity of MIDI notes, must be between 0 and 127
//144 = 10010000 in binary, note on command
int noteON = 144;
//128 = 10000000 in binary, note off command
int noteOFF = 128;

//Sets all of the numerical values of the solenoids, LED's, scales, scan speed, switches, and MIDI
int solenoid_1 = 22;
int solenoid_2 = 24;
int solenoid_3 = 26;
int solenoid_4 = 28;
int solenoid_5 = 30;
int solenoid_6 = 32;
int solenoid_7 = 34;
int solenoid_8 = 36;
int solenoid_9 = 38;
int solenoid_10 = 40;
int solenoid_11 = 42;
int solenoid_12 = 44;
int solenoid_13 = 46;
int solenoid_14 = 48;
int solenoid_15 = 50;

int step_ = 13;
int random_ = 12;
int auto_scan = 11;
int auto_step_scan = 10;
int step_scan = 9;
int up_down = 8;
int up_down_repeat = 7;
int up_down_repeat_skip = 6;
int scale_1 = 53;
int scale_2 = 51;
int scale_3 = 49;
int scale_4 = 47;
int scale_5 = 45;
int scale_6 = 43;
int scale_7 = 41;
int scale_8 = 39;
int scan_speed = A14;
int button_1 = 37;
int button_2 = 35;
int button_3 = 33;
int button_4 = 31;

int button_condition1 = 0;
int button_condition2 = 0;
int button_condition3 = 0;
int button_condition4 = 0;
int const1 = 0;
int const2 = 0;
int const3 = 0;
int const4 = 0;
int const5 = 0;
int const6 = 0;
int const7 = 0;
int const8 = 0;
int const9 = 0;
int const10 = 0;
int const11 = 0;
int const12 = 0;
int const13 = 0;
int const14 = 0;
int const15 = 0;
int const16 = 0;
int n = 0;
int m = 0;
float q = 0;
int i = 0;
int j = 0;
int g = 0;
int h = 0;
int fire1 = 0;
int fire2 = false;
int fire3 = false;
int fire4 = false;
float pot = 0;
int timeStep = 0;
int LEDdelay = 0;
int scaleNumber = 0;

int solenoid_scale[8][15] = {
  {22, 24, 26, 28, 30, 32, 34, 36, 38, 40, 42, 44, 46, 48, 50}, //Full Scale
  {22, 24, 28, 30, 32, 36, 38, 42, 44, 46, 50, 22, 22, 22, 22}, //F Major Penatonic
  {22, 24, 28, 30, 34, 36, 38, 42, 44, 48, 50, 22, 22, 22, 22}, //Bb Penatonic
  {22, 24, 26, 30, 32, 36, 38, 40, 44, 46, 50, 22, 22, 22, 22}, //C Scale
  {24, 26, 30, 32, 34, 38, 40, 44, 46, 48, 50, 22, 22, 22, 22}, //G Scale
  {22, 24, 26, 30, 32, 36, 38, 40, 44, 46, 50, 22, 22, 22, 22}, //Egyptian 1
  {22, 26, 28, 32, 34, 36, 40, 42, 46, 48, 50, 22, 22, 22, 22}, //Japanese
  {22, 24, 28, 30, 34, 36, 38, 42, 44, 48, 50, 22, 22, 22, 22}, //Egyptian 2
};

int LED_scale[8][15] = {
  {0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10, 11, 12, 13, 14}, 
  {0, 1, 3, 4, 5, 7, 8, 10, 11, 12, 14, 22, 22, 22, 22}, 
  {0, 1, 3, 4, 6, 7, 8, 10, 11, 13, 14, 22, 22, 22, 22}, 
  {0, 1, 2, 4, 5, 7, 8, 9, 11, 12, 14, 22, 22, 22, 22}, 
  {1, 2, 4, 5, 6, 8, 9, 11, 12, 13, 14, 22, 22, 22, 22}, 
  {0, 1, 2, 4, 5, 7, 8, 9, 11, 12, 14, 22, 22, 22, 22}, 
  {0, 2, 3, 5, 6, 7, 9, 10, 12, 13, 14, 22, 22, 22, 22}, 
  {0, 1, 3, 4, 6, 7, 8, 10, 11, 13, 14, 22, 22, 22, 22},
};

int MIDI_scale[8][15] = {
  {36, 38, 40, 41, 43, 45, 46, 48, 50, 52, 53, 55, 57, 58, 60},
  {36, 38, 41, 43, 45, 48, 50, 53, 55, 57, 60, 36, 36, 36, 36},
  {36, 38, 41, 43, 46, 48, 50, 53, 55, 58, 60, 36, 36, 36, 36},
  {36, 38, 40, 43, 45, 48, 50, 52, 55, 57, 60, 36, 36, 36, 36},
  {38, 40, 41, 45, 46, 50, 52, 55, 57, 58, 60, 36, 36, 36, 36},
  {36, 38, 43, 43, 45, 48, 50, 52, 55, 57, 60, 36, 36, 36, 36},
  {36, 40, 41, 45, 46, 48, 52, 53, 57, 58, 60, 36, 36, 36, 36},
  {36, 38, 41, 43, 46, 48, 50, 53, 55, 58, 60, 36, 36, 36, 36},
};

void setup() {
//initiate serial communication
  Serial.begin(9600);
  Serial2.begin(31250);

//delay time step
  timeStep = 150;

//initialize LED strip
  strip.begin();
  strip.show();
  
//solenoid numbering - sets all the pins to outputs
  pinMode(solenoid_1, OUTPUT); //C
  pinMode(solenoid_2, OUTPUT); //D
  pinMode(solenoid_3, OUTPUT); //E
  pinMode(solenoid_4, OUTPUT); //F
  pinMode(solenoid_5, OUTPUT); //G
  pinMode(solenoid_6, OUTPUT); //A
  pinMode(solenoid_7, OUTPUT); //Bb
  pinMode(solenoid_8, OUTPUT); //C
  pinMode(solenoid_9, OUTPUT); //D
  pinMode(solenoid_10, OUTPUT); //E
  pinMode(solenoid_11, OUTPUT); //F
  pinMode(solenoid_12, OUTPUT); //G
  pinMode(solenoid_13, OUTPUT); //A
  pinMode(solenoid_14, OUTPUT); //Bb
  pinMode(solenoid_15, OUTPUT); //C

//Switch Ensamble Functions - sets all the pins to inputs
  pinMode(step_, OUTPUT);
  pinMode(random_, OUTPUT);
  pinMode(auto_scan, OUTPUT);
  pinMode(auto_step_scan, OUTPUT);
  pinMode(step_scan, OUTPUT);
  pinMode(up_down, OUTPUT);
  pinMode(up_down_repeat, OUTPUT);
  pinMode(up_down_repeat_skip, OUTPUT);

//Scales - sets all the pins to inputs
  pinMode(scale_1, OUTPUT);
  pinMode(scale_2, OUTPUT);
  pinMode(scale_3, OUTPUT);
  pinMode(scale_4, OUTPUT);
  pinMode(scale_5, OUTPUT);
  pinMode(scale_6, OUTPUT);
  pinMode(scale_7, OUTPUT);
  pinMode(scale_8, OUTPUT);

//Scan Speed - sets the pin to input
//  pinMode(scan_speed, INPUT);

//Switches - sets all the pins to inputs
  pinMode(button_1, OUTPUT);
  pinMode(button_2, OUTPUT);
  pinMode(button_3, OUTPUT);
  pinMode(button_4, OUTPUT);

//sets all of the relays to be on
  digitalWrite(solenoid_1, HIGH);
  digitalWrite(solenoid_2, HIGH);
  digitalWrite(solenoid_3, HIGH);
  digitalWrite(solenoid_4, HIGH);
  digitalWrite(solenoid_5, HIGH);
  digitalWrite(solenoid_6, HIGH);
  digitalWrite(solenoid_7, HIGH);
  digitalWrite(solenoid_8, HIGH);
  digitalWrite(solenoid_9, HIGH);
  digitalWrite(solenoid_10, HIGH);
  digitalWrite(solenoid_11, HIGH);
  digitalWrite(solenoid_12, HIGH);
  digitalWrite(solenoid_13, HIGH);
  digitalWrite(solenoid_14, HIGH);
  digitalWrite(solenoid_15, HIGH);
}

void loop() {
  
//creates constant values for the if statements below
  const1 = digitalRead(scale_1);
  const2 = digitalRead(scale_2);
  const3 = digitalRead(scale_3);
  const4 = digitalRead(scale_4);
  const5 = digitalRead(scale_5);
  const6 = digitalRead(scale_6);
  const7 = digitalRead(scale_7);
  const8 = digitalRead(scale_8);

//sets the m value to specifiy which scale to use
//F major scale/ D minor scale
  if (const1 == HIGH){
    //F G A Bb C D E F G
    m = 0;
  }
//Egypt 2
  else if (const2 == HIGH){
    //C D F G Bb C
    m = 1;
  }
//F pentatonic
  else if (const3 == HIGH){
    //F G A C D F G
    m = 2;
  }

//Bb pentatonic
  else if (const4 == HIGH){
    //Bb C D F G Bb C
    m = 3;
  }

//C pentatonic
  else if (const5 == HIGH){
    //C D E G A C D
    m = 4;
  }

//G pentatonic  
  else if (const6 == HIGH){
    //G A Bb D E G A
    m = 5;
  }

// Egyptian pentatonic
  else if (const7 == HIGH){
    //D E G A C D E
    m = 6;
  }
  
// Japanese pentatonic
  else if (const8 == HIGH){
    //E F A Bb C E F
    m = 7;
  }

//creates constant values for the if statements below
  const9 = digitalRead(step_);                 
  const10 = digitalRead(random_);
  const11 = digitalRead(auto_scan);
  const12 = digitalRead(auto_step_scan);
  const13 = digitalRead(step_scan);
  const14 = digitalRead(up_down);
  const15 = digitalRead(up_down_repeat);
  const16 = digitalRead(up_down_repeat_skip);
  
// sets the n value specifiy which Switch Ensamble function to use
  if (const9 == HIGH){                       
    n = 0;
  }
  else if (const10 == HIGH){
    n = 1;
  }
  else if (const11 == HIGH){
    n = 2;
  }
  else if (const12 == HIGH){
    n = 3;
  }
  else if (const13 == HIGH){
    n = 4;
  }
  else if (const14 == HIGH){
    n = 5;
  }
  else if (const15 == HIGH){
    n = 6;
  }
  else if (const16 == HIGH){
    n = 7;
  }
  //Serial.print(n);

//switch cases for each of the 8 Switch Ensamble Functions with input n
  switch(n) {                              
    i = 0; 
    j = 0;
    g = 0;                              

//step
    case 0:
      for (g = 0; g < 15; g++){
        strip.setPixelColor(g,0,0,0);
        strip.show();
      }     
      if (m == 0){
        scaleNumber = 14; 
      }
      else{
        scaleNumber = 10;
      }                       
      if (i <= scaleNumber){
        button_condition1 = digitalRead(button_1);
        if (button_condition1 == LOW){
          fire1 = 0;
        }
        if (button_condition1 == HIGH && fire1 == 0){
          digitalWrite(solenoid_scale[m][i], LOW); //turns on the solenoid (i) using scale (m)
          MIDImessage(noteON, MIDI_scale[m][j], velocity);
          delay(100);
          digitalWrite(solenoid_scale[m][i], HIGH);  //turns off the solenoid
          MIDImessage(noteOFF, MIDI_scale[m][j], velocity);
          delay(timeStep);
          i++;
          j++;
          fire1 = 1;
          //Serial.print(i);
        }
        else{
          digitalWrite(solenoid_scale[m][i], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][j], velocity);
          strip.setPixelColor(i,0,0,0);
          strip.show();
        }
      }   
      else{
        i = 0;
        j = 0;
      }
      break;

//random
    case 1: 
      for (g = 0; g < 15; g++){
        strip.setPixelColor(g,0,0,0);
        strip.show();
      }   
      if (m == 0){
          scaleNumber = 14; 
        }
        else{
          scaleNumber = 10;
        }                              
      i = rand()%scaleNumber;
        button_condition1 = digitalRead(button_1);
        if (button_condition1 == LOW){
          fire1 = 0;
        }
        if (button_condition1 == HIGH && fire1 == 0){
          digitalWrite(solenoid_scale[m][i], LOW); 
          MIDImessage(noteON, MIDI_scale[m][i], velocity);
          delay(100);
          digitalWrite(solenoid_scale[m][i], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][i], velocity);
          delay(timeStep);
          fire1 = 1;
          //Serial.print(i);
        }
        else{
          digitalWrite(solenoid_scale[m][i], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][i], velocity);
        }
      break;

//auto scan
    case 2:  
      q = analogRead(scan_speed);
      //Serial.println(q);
      pot = q/1023;
      LEDdelay = 5000-(pot*4500);
      if (m == 0){
        scaleNumber = 14; 
      }
      else{
        scaleNumber = 10;
      }
      strip.setPixelColor(LED_scale[m][g],0,0,0);
      strip.show();          
      button_condition1 = digitalRead(button_1);
      if (button_condition1 == LOW){
          fire1 = 0;
      }
      if (button_condition1 == HIGH && fire1 == 0){
        delay(500);
        currentMillis = millis(); 
        previousMillis1 = currentMillis;
        button_condition1 = digitalRead(button_1);
        fire1 = 1;
        while (button_condition1 == LOW || fire1 == 1){
          if (g <= scaleNumber){             
            strip.setPixelColor(LED_scale[m][g],255,255,255);
            strip.show();
            currentMillis = millis();
            if (currentMillis-previousMillis1 > LEDdelay){
              strip.setPixelColor(LED_scale[m][g],0,0,0);
              strip.show();
              previousMillis1 = currentMillis;
              g++;
            }
            button_condition1 = digitalRead(button_1);
            if (button_condition1 == LOW){
              fire1 = 0;
            }
          }
          else{
            g = 0;
          }
        }
        strip.setPixelColor(LED_scale[m][g],0,0,0);
        strip.show();
        digitalWrite(solenoid_scale[m][g], LOW); 
        MIDImessage(noteON, MIDI_scale[m][g], velocity);
        delay(100);
        digitalWrite(solenoid_scale[m][g], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][g], velocity);
        delay(timeStep);
        g = 0;
        fire1 = 1;
      }
      else{
        digitalWrite(solenoid_scale[m][g], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][g], velocity);
      }    
      break;

//auto step scan
    case 3:     
      q = analogRead(scan_speed);
      //Serial.println(q);
      pot = q/1023;
      LEDdelay = 5000-(pot*4500);
      if (m == 0){
        scaleNumber = 14; 
      }
      else{
        scaleNumber = 10;
      }                           
      strip.setPixelColor(LED_scale[m][g],0,0,0);
      strip.show();          
      button_condition1 = digitalRead(button_1);
      if (button_condition1 == LOW){
          fire1 = 0;
        }
      if (button_condition1 == HIGH && fire1 == 0){
        delay(500);
        currentMillis = millis(); 
        previousMillis1 = currentMillis;
        button_condition1 = digitalRead(button_1);
        fire1 = 1;
        while (button_condition1 == LOW || fire1 == 1){
          if (g <= scaleNumber){             
            strip.setPixelColor(LED_scale[m][g],255,255,255);
            strip.show();
            currentMillis = millis();
            if (currentMillis-previousMillis1 > LEDdelay){
              strip.setPixelColor(LED_scale[m][g],0,0,0);
              strip.show();
              previousMillis1 = currentMillis;
              g++;
            }
            button_condition1 = digitalRead(button_1);
            if (button_condition1 == LOW){
              fire1 = 0;
            }
          }
          else{
            g = 0;
          }
        }
        delay(250);
        fire1 = 1;
        button_condition1 = digitalRead(button_1);
        while (button_condition1 == LOW || fire1 == 1){
          strip.setPixelColor(LED_scale[m][g],255,0,0);
          strip.show();
          button_condition1 = digitalRead(button_1);
          if (button_condition1 == LOW){
          fire1 = 0;
          }
        }
        strip.setPixelColor(LED_scale[m][g],0,0,0);
        strip.show();
        digitalWrite(solenoid_scale[m][g], LOW); 
        MIDImessage(noteON, MIDI_scale[m][g], velocity);
        delay(100);
        digitalWrite(solenoid_scale[m][g], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][g], velocity);
        delay(timeStep);
        g = 0;
        fire1 = 1;
      }
      else{
        digitalWrite(solenoid_scale[m][g], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][g], velocity);
      }   
      break;

//step scan
    case 4:    
      q = analogRead(scan_speed);
      Serial.println(q);
      pot = q/1023;
      LEDdelay = 5000-(pot*4500);
      if (m == 0){
        scaleNumber = 14; 
      }
      else{
        scaleNumber = 10;
      }                            
      if (g <= scaleNumber){
        button_condition1 = digitalRead(button_1);
        if (button_condition1 == LOW){
          fire1 = 0;
        }
        button_condition2 = digitalRead(button_2);
        if (button_condition2 == LOW){
          fire2 = 0;
        }
        if (button_condition1 == HIGH && fire1 == 0){
          strip.setPixelColor(LED_scale[m][g-1],0,0,0);
          strip.show();
          if (g == 0){
            strip.setPixelColor(14,0,0,0);
            strip.show();
          }
          strip.setPixelColor(LED_scale[m][g],255,255,255);
          strip.show();
          g++;
          h = g-1;
          delay(timeStep);
          fire1 = 1;
        }
        else if (button_condition2 == HIGH && fire2 == 0){
          digitalWrite(solenoid_scale[m][h], LOW); 
          MIDImessage(noteON, MIDI_scale[m][h], velocity);
          delay(100);
          digitalWrite(solenoid_scale[m][h], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
          delay(timeStep);
          fire2 = 1;
          //Serial.print(i);
        }
        else{
          digitalWrite(solenoid_scale[m][h], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
        }
      }   
      else{
        g = 0;
      }
      break;

//up down
    case 5: 
      for (g = 0; g < 15; g++){
        strip.setPixelColor(g,0,0,0);
        strip.show();
      }     
      if (m == 0){
        scaleNumber = 14; 
      }
      else{
        scaleNumber = 10;
      }                         
      button_condition1 = digitalRead(button_1);
      if (button_condition1 == LOW){
          fire1 = 0;
        }
      button_condition2 = digitalRead(button_2);
      if (button_condition2 == LOW){
          fire2 = 0;
        }
      if (button_condition1 == HIGH && fire1 == 0){
        i++;
        if (i >= scaleNumber+2){
          i = 1;
        }
        h = i-1;
        digitalWrite(solenoid_scale[m][h], LOW); 
        MIDImessage(noteON, MIDI_scale[m][h], velocity);
        delay(100);
        digitalWrite(solenoid_scale[m][h], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
        delay(timeStep);
        fire1 = 1;
        //Serial.print(i);
      }
      else if (button_condition2 == HIGH && fire2 == 0){
        i--;
        h--;
        if (h <= -1){
          i = scaleNumber+1;
          h = scaleNumber;
          digitalWrite(solenoid_scale[m][h], LOW); 
          MIDImessage(noteON, MIDI_scale[m][h], velocity);
          delay(100);
          digitalWrite(solenoid_scale[m][h], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
          delay(timeStep);
          fire2 = 1;
        }
        else{
          digitalWrite(solenoid_scale[m][h], LOW); 
          MIDImessage(noteON, MIDI_scale[m][h], velocity);
          delay(100);
          digitalWrite(solenoid_scale[m][h], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
          delay(timeStep);
          fire2 = 1;
        }
      }
      else{
        digitalWrite(solenoid_scale[m][h], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
      } 
      break;

//up down repeat
    case 6:    
      for (g = 0; g < 15; g++){
        strip.setPixelColor(g,0,0,0);
        strip.show();
      }     
      if (m == 0){
        scaleNumber = 14; 
      }
      else{
        scaleNumber = 10;
      }                         
      button_condition1 = digitalRead(button_1);
      if (button_condition1 == LOW){
          fire1 = 0;
        }
      button_condition2 = digitalRead(button_2);
      if (button_condition2 == LOW){
          fire2 = 0;
        }
      button_condition3 = digitalRead(button_3);
      if (button_condition3 == LOW){
          fire3 = 0;
        }
      if (button_condition1 == HIGH && fire1 == 0){
        i++;
        if (i >= scaleNumber+2){
          i = 1;
        }
        h = i-1;
        digitalWrite(solenoid_scale[m][h], LOW); 
        MIDImessage(noteON, MIDI_scale[m][h], velocity);
        delay(100);
        digitalWrite(solenoid_scale[m][h], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
        delay(timeStep);
        fire1 = 1;
        //Serial.print(i);
      }
      else if (button_condition2 == HIGH && fire2 == 0){
        i--;
        h--;
        if (h <= -1){
          i = scaleNumber+1;
          h = scaleNumber;
          digitalWrite(solenoid_scale[m][h], LOW); 
          MIDImessage(noteON, MIDI_scale[m][h], velocity);
          delay(100);
          digitalWrite(solenoid_scale[m][h], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
          delay(timeStep);
          fire2 = 1;
        }
        else{
          digitalWrite(solenoid_scale[m][h], LOW); 
          MIDImessage(noteON, MIDI_scale[m][h], velocity);
          delay(100);
          digitalWrite(solenoid_scale[m][h], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
          delay(timeStep);
          fire2 = 1;
        }
      }
      else if (button_condition3 == HIGH && fire3 == 0){
        digitalWrite(solenoid_scale[m][h], LOW); 
        MIDImessage(noteON, MIDI_scale[m][h], velocity);
        delay(100);
        digitalWrite(solenoid_scale[m][h], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
        delay(timeStep);
        fire3 = 1;
      }
      else{
        digitalWrite(solenoid_scale[m][h], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
      } 
      break;

//up down repeat skip
    case 7:
      for (g = 0; g < 15; g++){
          strip.setPixelColor(g,0,0,0);
          strip.show();
        }  
      if (m == 0){
        scaleNumber = 14; 
      }
      else{
        scaleNumber = 10;
      }
      button_condition1 = digitalRead(button_1);
      if (button_condition1 == LOW){
          fire1 = 0;
        }
      button_condition2 = digitalRead(button_2);
      if (button_condition2 == LOW){
          fire2 = 0;
        }
      button_condition3 = digitalRead(button_3);
      if (button_condition3 == LOW){
          fire3 = 0;
        }
      button_condition4 = digitalRead(button_4);
      if (button_condition4 == LOW){
          fire4 = 0;
        }
      if (button_condition1 == HIGH && fire1 == 0){
        i++;
        if (i >= scaleNumber+2){
          i = 1;
        }
        h = i-1;
        digitalWrite(solenoid_scale[m][h], LOW); 
        MIDImessage(noteON, MIDI_scale[m][h], velocity);
        delay(100);
        digitalWrite(solenoid_scale[m][h], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
        delay(timeStep);
        fire1 = 1;
        //Serial.print(i);
      }
      else if (button_condition2 == HIGH && fire2 == 0){
        i--;
        h--;
        if (h <= -1){
          i = scaleNumber+1;
          h = scaleNumber;
          digitalWrite(solenoid_scale[m][h], LOW); 
          MIDImessage(noteON, MIDI_scale[m][h], velocity);
          delay(100);
          digitalWrite(solenoid_scale[m][h], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
          delay(timeStep);
          fire2 = 1;
        }
        else{
          digitalWrite(solenoid_scale[m][h], LOW); 
          MIDImessage(noteON, MIDI_scale[m][h], velocity);
          delay(100);
          digitalWrite(solenoid_scale[m][h], HIGH);
          MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
          delay(timeStep);
          fire2 = 1;
        }
      }
      else if (button_condition3 == HIGH && fire3 == 0){
        digitalWrite(solenoid_scale[m][h], LOW); 
        MIDImessage(noteON, MIDI_scale[m][h], velocity);
        delay(100);
        digitalWrite(solenoid_scale[m][h], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
        delay(timeStep);
        fire3 = 1;
      }
      else if (button_condition4 == HIGH && fire4 == 0){
        i = i+2;
        if (i == scaleNumber+2){
          i = 1;
        }
        else if(i >= scaleNumber+3){
          i = 2;  
        }
        h = i-1;
        digitalWrite(solenoid_scale[m][h], LOW); 
        MIDImessage(noteON, MIDI_scale[m][h], velocity);
        delay(100);
        digitalWrite(solenoid_scale[m][h], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
        delay(timeStep);
        fire4 = 1;
      }
      else{
        digitalWrite(solenoid_scale[m][h], HIGH);
        MIDImessage(noteOFF, MIDI_scale[m][h], velocity);
      } 
      break;
  }
}

//send MIDI message
void MIDImessage(int command, int MIDInote, int MIDIvelocity) {
  Serial2.write(command);//send note on or note off command 
  Serial2.write(MIDInote);//send pitch data
  Serial2.write(MIDIvelocity);//send velocity data
}
